"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const md5_1 = __importDefault(require("md5"));
module.exports = (_a = class MiniCssExtractPlugin {
        constructor(options) {
            this.filename = options.filename;
        }
        apply(hooks) {
            hooks.beforeEmit.tap("MiniCssExtractPlugin", (entryName, moduleMap, modulePaths, assets) => {
                let targetCode = this.getTargetCode(moduleMap, modulePaths);
                if (!targetCode)
                    return;
                let filename = this.filename.replace(/\[name\]/g, entryName);
                filename = filename.replace(/\[hash:(\d+)\]/g, (value, length) => {
                    return (0, md5_1.default)(targetCode).substring(0, length);
                });
                fs_1.default.writeFileSync(path_1.default.join(__webpack_public_path__, filename), targetCode);
                assets.push({
                    type: "css",
                    url: "./" + filename,
                });
            });
        }
        getTargetCode(moduleMap, modulePaths) {
            let targetCode = "";
            let cssPaths = [];
            function __webpack_require__(moduleIndex) {
                let modulePath = modulePaths[moduleIndex];
                let code = moduleMap[modulePath].replace(/\\"/g, '"').replace(/\\{1,2}n/g, (value) => {
                    return value == "\\n" ? "\n" : "\\n";
                });
                let exports = {};
                let module = { exports };
                eval(code);
                if (Array.isArray(module.exports)) {
                    cssPaths.push(modulePath);
                }
                return module.exports;
            }
            for (let entryPath of _a.entryPaths) {
                let entryIndex = modulePaths.indexOf(entryPath);
                targetCode += __webpack_require__(entryIndex) + "\n";
                moduleMap[entryPath] = "";
            }
            for (let cssPath of cssPaths) {
                delete moduleMap[cssPath];
            }
            return targetCode;
        }
    },
    _a.entryPaths = [],
    _a.loader = "@small-webpack/mini-css-extract-plugin/dist/loader.js",
    _a);
